/*!
 * Copyright (c) 2012 - 2019, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(root, factory) {
  factory(root["Bokeh"]);
})(this, function(Bokeh) {
  var define;
  return (function(modules, entry, aliases, externals) {
    if (Bokeh != null) {
      return Bokeh.register_plugin(modules, entry, aliases, externals);
    } else {
      throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
    }
  })
({
"38f4b8800f": function _(e,s,b){var o=e("b9b392174d");b.GeoViews=o,e("@bokehjs/base").register_models(o)},
"b9b392174d": function _(o,e,l){var r=o("27f5421c63");l.CheckpointTool=r.CheckpointTool;var a=o("65e2b641a2");l.ClearTool=a.ClearTool;var t=o("bf8d72a956");l.PolyVertexDrawTool=t.PolyVertexDrawTool;var T=o("548fd712fd");l.PolyVertexEditTool=T.PolyVertexEditTool;var f=o("f3e27c114e");l.RestoreTool=f.RestoreTool},
"27f5421c63": function _(o,t,e){var n,r=this&&this.__extends||(n=function(o,t){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(o,t){o.__proto__=t}||function(o,t){for(var e in t)t.hasOwnProperty(e)&&(o[e]=t[e])})(o,t)},function(o,t){function e(){this.constructor=o}n(o,t),o.prototype=null===t?Object.create(t):(e.prototype=t.prototype,new e)}),i=o("@bokehjs/core/properties"),c=o("@bokehjs/core/util/array"),s=o("@bokehjs/models/tools/actions/action_tool"),a=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return r(t,o),t.prototype.doit=function(){for(var o=0,t=this.model.sources;o<t.length;o++){var e=t[o];e.buffer||(e.buffer=[]);var n={};for(var r in e.data){for(var i=[],s=0,a=e.data[r];s<a.length;s++){var u=a[s];Array.isArray(u)||ArrayBuffer.isView(u)?i.push(c.copy(u)):i.push(u)}n[r]=i}e.buffer.push(n)}},t.__name__="CheckpointToolView",t}(s.ActionToolView);e.CheckpointToolView=a;var u=function(o){function t(t){var e=o.call(this,t)||this;return e.tool_name="Checkpoint",e.icon="bk-tool-icon-save",e}return r(t,o),t.init_CheckpointTool=function(){this.prototype.default_view=a,this.define({sources:[i.Array,[]]})},t.__name__="CheckpointTool",t.__module__="geoviews.models.custom_tools",t}(s.ActionTool);e.CheckpointTool=u,u.init_CheckpointTool()},
"65e2b641a2": function _(o,t,e){var n,r=this&&this.__extends||(n=function(o,t){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(o,t){o.__proto__=t}||function(o,t){for(var e in t)t.hasOwnProperty(e)&&(o[e]=t[e])})(o,t)},function(o,t){function e(){this.constructor=o}n(o,t),o.prototype=null===t?Object.create(t):(e.prototype=t.prototype,new e)}),i=o("@bokehjs/core/properties"),a=o("@bokehjs/models/tools/actions/action_tool"),l=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return r(t,o),t.prototype.doit=function(){for(var o=0,t=this.model.sources;o<t.length;o++){var e=t[o];for(var n in e.data)e.data[n]=[];e.change.emit(),e.properties.data.change.emit()}},t.__name__="ClearToolView",t}(a.ActionToolView);e.ClearToolView=l;var s=function(o){function t(t){var e=o.call(this,t)||this;return e.tool_name="Clear data",e.icon="bk-tool-icon-reset",e}return r(t,o),t.init_ClearTool=function(){this.prototype.type="ClearTool",this.prototype.default_view=l,this.define({sources:[i.Array,[]]})},t.__name__="ClearTool",t.__module__="geoviews.models.custom_tools",t}(a.ActionTool);e.ClearTool=s,s.init_ClearTool()},
"bf8d72a956": function _(e,t,r){var o,l=this&&this.__extends||(o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)},function(e,t){function r(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),s=e("@bokehjs/core/properties"),a=e("@bokehjs/core/util/object"),i=e("@bokehjs/core/util/types"),n=e("@bokehjs/models/tools/edit/poly_draw_tool"),d=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return l(t,e),t.prototype._split_path=function(e,t){for(var r=0;r<this.model.renderers.length;r++)for(var o=this.model.renderers[r],l=o.glyph,s=o.data_source,a=[l.xs.field,l.ys.field],n=a[0],d=a[1],h=s.data[n],_=s.data[d],y=0;y<h.length;y++){var p=h[y];i.isArray(p)||(p=Array.from(p),s.data[n][y]=p);var c=_[y];i.isArray(c)||(c=Array.from(c),s.data[d][y]=c);for(var f=0;f<p.length;f++)if(p[f]==e&&c[f]==t&&0!=f&&f!=p.length-1){h.splice(y+1,0,p.slice(f)),_.splice(y+1,0,c.slice(f)),p.splice(f+1),c.splice(f+1);for(var v=0,u=s.columns();v<u.length;v++){var g=u[v];g!==n&&g!=d&&s.data[g].splice(y+1,0,s.data[g][y])}return}}},t.prototype._snap_to_vertex=function(e,t,r){if(this.model.vertex_renderer){var o=this._select_event(e,!1,[this.model.vertex_renderer]),l=this.model.vertex_renderer.data_source,s=this.model.vertex_renderer.glyph,a=[s.x.field,s.y.field],i=a[0],n=a[1];if(o.length){var d=l.selected.indices[0];i&&(t=l.data[i][d]),n&&(r=l.data[n][d]),"mousemove"!=e.type&&this._split_path(t,r),l.selection_manager.clear()}}return[t,r]},t.prototype._set_vertices=function(e,t,r){var o=this.model.vertex_renderer.glyph,l=this.model.vertex_renderer.data_source,s=[o.x.field,o.y.field],n=s[0],d=s[1];if(n&&(i.isArray(e)?l.data[n]=e:o.x={value:e}),d&&(i.isArray(t)?l.data[d]=t:o.y={value:t}),null!=r)for(var h=0,_=a.keys(r);h<_.length;h++){var y=_[h];l.data[y]=r[y],o[y]={field:y}}else for(var p=0,c=l.columns();p<c.length;p++){var f=c[p];l.data[f]=[]}this._emit_cds_changes(l,!0,!0,!1)},t.prototype._show_vertices=function(){if(this.model.active){for(var e=[],t=[],r={},o=0,l=a.keys(this.model.end_style);o<l.length;o++){r[w=l[o]]=[]}for(var s=0;s<this.model.renderers.length;s++){for(var i=this.model.renderers[s],n=i.data_source,d=i.glyph,h=[d.xs.field,d.ys.field],_=h[0],y=h[1],p=0,c=n.get_array(_);p<c.length;p++){var f=c[p];Array.prototype.push.apply(e,f);for(var v=0,u=a.keys(this.model.end_style);v<u.length;v++){r[w=u[v]].push(this.model.end_style[w])}for(var g=0,m=a.keys(this.model.node_style);g<m.length;g++)for(var w=m[g],x=0;x<f.length-2;x++)r[w].push(this.model.node_style[w]);for(var A=0,k=a.keys(this.model.end_style);A<k.length;A++){r[w=k[A]].push(this.model.end_style[w])}}for(var P=0,V=n.get_array(y);P<V.length;P++){f=V[P];Array.prototype.push.apply(t,f)}if(this._drawing&&s==this.model.renderers.length-1){e.splice(e.length-1,1),t.splice(t.length-1,1);for(var D=0,T=a.keys(r);D<T.length;D++){r[w=T[D]].splice(r[w].length-1,1)}}}this._set_vertices(e,t,r)}},t.prototype._remove=function(){var e=this.model.renderers[0],t=e.data_source,r=e.glyph,o=[r.xs.field,r.ys.field],l=o[0],s=o[1];if(l){var a=t.data[l].length-1,i=t.get_array(l)[a];i.splice(i.length-1,1),1==i.length&&t.data[l].splice(a,1)}if(s){var n=t.data[s].length-1,d=t.get_array(s)[n];d.splice(d.length-1,1),1==d.length&&t.data[s].splice(n,1)}this._emit_cds_changes(t),this._drawing=!1,this._show_vertices()},t.__name__="PolyVertexDrawToolView",t}(n.PolyDrawToolView);r.PolyVertexDrawToolView=d;var h=function(e){function t(t){return e.call(this,t)||this}return l(t,e),t.init_PolyVertexDrawTool=function(){this.prototype.default_view=d,this.define({end_style:[s.Any,{}],node_style:[s.Any,{}]})},t.__name__="PolyVertexDrawTool",t.__module__="geoviews.models.custom_tools",t}(n.PolyDrawTool);r.PolyVertexDrawTool=h,h.init_PolyVertexDrawTool()},
"548fd712fd": function _(e,t,r){var s,i=this&&this.__extends||(s=function(e,t){return(s=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)},function(e,t){function r(){this.constructor=e}s(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),o=e("@bokehjs/core/properties"),n=e("@bokehjs/core/util/object"),_=e("@bokehjs/core/util/types"),d=e("@bokehjs/models/tools/edit/poly_edit_tool"),a=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return i(t,e),t.prototype.deactivate=function(){this._hide_vertices(),this._selected_renderer&&(this._drawing&&(this._remove_vertex(),this._drawing=!1),this._emit_cds_changes(this._selected_renderer.data_source,!1,!0,!1))},t.prototype._pan=function(e){if(null!=this._basepoint){var t=this._drag_points(e,[this.model.vertex_renderer]);e.shiftKey||this._move_linked(t),this._selected_renderer&&this._selected_renderer.data_source.change.emit()}},t.prototype._pan_end=function(e){if(null!=this._basepoint){var t=this._drag_points(e,[this.model.vertex_renderer]);e.shiftKey||this._move_linked(t),this._emit_cds_changes(this.model.vertex_renderer.data_source,!1,!0,!0),this._selected_renderer&&this._emit_cds_changes(this._selected_renderer.data_source),this._basepoint=null}},t.prototype._drag_points=function(e,t){if(null==this._basepoint)return[];for(var r=this._basepoint,s=r[0],i=r[1],o=[],n=0,_=t;n<_.length;n++){var d=_[n],a=this._map_drag(s,i,d),l=this._map_drag(e.sx,e.sy,d);if(null!=l&&null!=a){for(var h=l[0],c=l[1],u=[h-a[0],c-a[1]],y=u[0],p=u[1],f=d.glyph,v=d.data_source,g=[f.x.field,f.y.field],m=g[0],x=g[1],b=0,w=v.selected.indices;b<w.length;b++){var k=w[b],P=[];m&&(P.push(v.data[m][k]),v.data[m][k]+=y),x&&(P.push(v.data[x][k]),v.data[x][k]+=p),P.push(y),P.push(p),o.push(P)}v.change.emit()}}return this._basepoint=[e.sx,e.sy],o},t.prototype._set_vertices=function(e,t,r){var s=this.model.vertex_renderer.glyph,i=this.model.vertex_renderer.data_source,o=[s.x.field,s.y.field],d=o[0],a=o[1];if(d&&(_.isArray(e)?i.data[d]=e:s.x={value:e}),a&&(_.isArray(t)?i.data[a]=t:s.y={value:t}),null!=r)for(var l=0,h=n.keys(r);l<h.length;l++){var c=h[l];i.data[c]=r[c],s[c]={field:c}}else for(var u=0,y=i.columns();u<y.length;u++){var p=y[u];i.data[p]=[]}this._emit_cds_changes(i,!0,!0,!1)},t.prototype._move_linked=function(e){if(this._selected_renderer)for(var t=this._selected_renderer,r=t.glyph,s=t.data_source,i=[r.xs.field,r.ys.field],o=i[0],n=i[1],_=s.data[o],d=s.data[n],a=0,l=e;a<l.length;a++)for(var h=l[a],c=h[0],u=h[1],y=h[2],p=h[3],f=0;f<_.length;f++)for(var v=_[f],g=d[f],m=0;m<v.length;m++)v[m]==c&&g[m]==u&&(v[m]+=y,g[m]+=p)},t.prototype._tap=function(e){var t,r=this.model.vertex_renderer,s=this._map_drag(e.sx,e.sy,r);if(null!=s){if(this._drawing&&this._selected_renderer){var i=s[0],o=s[1],n=r.data_source,_=r.glyph,d=[_.x.field,_.y.field],a=d[0],l=d[1],h=n.selected.indices;i=(t=this._snap_to_vertex(e,i,o))[0],o=t[1];var c=h[0];if(n.selected.indices=[c+1],a){var u=n.get_array(a),y=u[c];u[c]=i,u.splice(c+1,0,y)}if(l){var p=n.get_array(l),f=p[c];p[c]=o,p.splice(c+1,0,f)}return n.change.emit(),void this._emit_cds_changes(this._selected_renderer.data_source,!0,!1,!0)}var v=e.shiftKey;this._select_event(e,v,[r])}},t.prototype._show_vertices=function(e){if(this.model.active){var t=this._select_event(e,!1,this.model.renderers);if(!t.length)return this._hide_vertices(),this._selected_renderer=null,void(this._drawing=!1);var r,s,i=t[0],o=i.glyph,d=i.data_source,a=d.selected.indices[0],l=[o.xs.field,o.ys.field],h=l[0],c=l[1];h?(r=d.data[h][a],_.isArray(r)||(d.data[h][a]=r=Array.from(r))):r=o.xs.value,c?(s=d.data[c][a],_.isArray(s)||(d.data[c][a]=s=Array.from(s))):s=o.ys.value;for(var u={},y=0,p=n.keys(this.model.end_style);y<p.length;y++){u[g=p[y]]=[this.model.end_style[g]]}for(var f=0,v=n.keys(this.model.node_style);f<v.length;f++)for(var g=v[f],m=0;m<r.length-2;m++)u[g].push(this.model.node_style[g]);for(var x=0,b=n.keys(this.model.end_style);x<b.length;x++){u[g=b[x]].push(this.model.end_style[g])}this._selected_renderer=i,this._set_vertices(r,s,u)}},t.__name__="PolyVertexEditToolView",t}(d.PolyEditToolView);r.PolyVertexEditToolView=a;var l=function(e){function t(t){return e.call(this,t)||this}return i(t,e),t.init_PolyVertexEditTool=function(){this.prototype.default_view=a,this.define({node_style:[o.Any,{}],end_style:[o.Any,{}]})},t.__name__="PolyVertexEditTool",t.__module__="geoviews.models.custom_tools",t}(d.PolyEditTool);r.PolyVertexEditTool=l,l.init_PolyVertexEditTool()},
"f3e27c114e": function _(o,t,e){var n,r=this&&this.__extends||(n=function(o,t){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(o,t){o.__proto__=t}||function(o,t){for(var e in t)t.hasOwnProperty(e)&&(o[e]=t[e])})(o,t)},function(o,t){function e(){this.constructor=o}n(o,t),o.prototype=null===t?Object.create(t):(e.prototype=t.prototype,new e)}),i=o("@bokehjs/core/properties"),s=o("@bokehjs/models/tools/actions/action_tool"),c=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return r(t,o),t.prototype.doit=function(){for(var o=0,t=this.model.sources;o<t.length;o++){var e=t[o];e.buffer&&0!=e.buffer.length&&(e.data=e.buffer.pop(),e.change.emit(),e.properties.data.change.emit())}},t.__name__="RestoreToolView",t}(s.ActionToolView);e.RestoreToolView=c;var u=function(o){function t(t){var e=o.call(this,t)||this;return e.tool_name="Restore",e.icon="bk-tool-icon-undo",e}return r(t,o),t.init_RestoreTool=function(){this.prototype.default_view=c,this.define({sources:[i.Array,[]]})},t.__name__="RestoreTool",t.__module__="geoviews.models.custom_tools",t}(s.ActionTool);e.RestoreTool=u,u.init_RestoreTool()},
}, "38f4b8800f", {"index":"38f4b8800f","models/index":"b9b392174d","models/checkpoint_tool":"27f5421c63","models/clear_tool":"65e2b641a2","models/poly_draw":"bf8d72a956","models/poly_edit":"548fd712fd","models/restore_tool":"f3e27c114e"}, {});
})

//# sourceMappingURL=geoviews.min.js.map
